'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _osFamily = require('os-family');

var _osFamily2 = _interopRequireDefault(_osFamily);

var _findWindow = require('./find-window');

var _findWindow2 = _interopRequireDefault(_findWindow);

var _utilsExec = require('../utils/exec');

var _binaries = require('../binaries');

var _binaries2 = _interopRequireDefault(_binaries);

var _utilsLogFile = require('../utils/log-file');

var _utilsLogFile2 = _interopRequireDefault(_utilsLogFile);

/**
 * Closes the browser window where the specified web page is opened.
 * @function
 * @async
 * @name close
 * @param {string | object} windowDescriptor - The title of the web page opened in the window or a descriptor returned by findWindow.
 */

exports.default = function callee$0$0(windowDescriptor) {
    var windowDescription, closeWindowArguments;
    return _regeneratorRuntime.async(function callee$0$0$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                _utilsLogFile2.default('close');

                if (!(typeof windowDescriptor === 'string')) {
                    context$1$0.next = 7;
                    break;
                }

                context$1$0.next = 4;
                return _regeneratorRuntime.awrap(_findWindow2.default(windowDescriptor));

            case 4:
                context$1$0.t0 = context$1$0.sent;
                context$1$0.next = 8;
                break;

            case 7:
                context$1$0.t0 = windowDescriptor;

            case 8:
                windowDescription = context$1$0.t0;

                if (windowDescription) {
                    context$1$0.next = 12;
                    break;
                }

                _utilsLogFile2.default('close failed to get window');

                return context$1$0.abrupt('return');

            case 12:
                closeWindowArguments = void 0;

                if (!_osFamily2.default.win) {
                    context$1$0.next = 17;
                    break;
                }

                closeWindowArguments = [windowDescription.hwnd];
                context$1$0.next = 26;
                break;

            case 17:
                if (!_osFamily2.default.mac) {
                    context$1$0.next = 21;
                    break;
                }

                closeWindowArguments = [windowDescription.windowId, windowDescription.bundleId];
                context$1$0.next = 26;
                break;

            case 21:
                if (!_osFamily2.default.linux) {
                    context$1$0.next = 25;
                    break;
                }

                closeWindowArguments = [windowDescription.windowId];
                context$1$0.next = 26;
                break;

            case 25:
                return context$1$0.abrupt('return');

            case 26:
                context$1$0.prev = 26;

                _utilsLogFile2.default('close before exec');
                context$1$0.next = 30;
                return _regeneratorRuntime.awrap(_utilsExec.execFile(_binaries2.default.close, closeWindowArguments));

            case 30:
                _utilsLogFile2.default('close after exec');
                context$1$0.next = 37;
                break;

            case 33:
                context$1$0.prev = 33;
                context$1$0.t1 = context$1$0['catch'](26);

                _utilsLogFile2.default('close error ' + context$1$0.t1.stack);
                throw context$1$0.t1;

            case 37:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this, [[26, 33]]);
};

module.exports = exports.default;