'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _osFamily = require('os-family');

var _osFamily2 = _interopRequireDefault(_osFamily);

var _os = require('os');

var _utilsExec = require('../utils/exec');

var _binaries = require('../binaries');

var _binaries2 = _interopRequireDefault(_binaries);

var _utilsLogFile = require('../utils/log-file');

var _utilsLogFile2 = _interopRequireDefault(_utilsLogFile);

/**
 * Retrieves a platform-specific window descriptor for the window that contains a web page with the specified title.
 * @function
 * @async
 * @name findWindow
 * @param {string} pageTitle - The title of the web page opened in a window whose descriptor should be retrieved.
 * @returns {object} a platform-specific window descriptor that can be used as a window identifier.
 **/

exports.default = function callee$0$0(pageTitle) {
    var res, windowParams;
    return _regeneratorRuntime.async(function callee$0$0$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                res = null;
                windowParams = [];

                _utilsLogFile2.default('find-window');

                context$1$0.prev = 3;

                _utilsLogFile2.default('find-window before 1st exec');

                context$1$0.next = 7;
                return _regeneratorRuntime.awrap(_utilsExec.execFile(_binaries2.default.findWindow, [pageTitle]));

            case 7:
                res = context$1$0.sent;

                _utilsLogFile2.default('find-window after 1st exec');

                if (!_osFamily2.default.mac) {
                    context$1$0.next = 15;
                    break;
                }

                _utilsLogFile2.default('find-window before 2nd exec');

                context$1$0.next = 13;
                return _regeneratorRuntime.awrap(_utilsExec.execFile(_binaries2.default.findWindowCocoa, [pageTitle]));

            case 13:
                res += context$1$0.sent;

                _utilsLogFile2.default('find-window after 2nd exec');

            case 15:
                context$1$0.next = 21;
                break;

            case 17:
                context$1$0.prev = 17;
                context$1$0.t0 = context$1$0['catch'](3);

                _utilsLogFile2.default('find-window ' + context$1$0.t0.stack);
                return context$1$0.abrupt('return', null);

            case 21:

                windowParams = res.split(_os.EOL);

                if (!_osFamily2.default.win) {
                    context$1$0.next = 24;
                    break;
                }

                return context$1$0.abrupt('return', { hwnd: windowParams[0], browser: windowParams[1] });

            case 24:
                if (!_osFamily2.default.mac) {
                    context$1$0.next = 27;
                    break;
                }

                _utilsLogFile2.default('find-window' + windowParams);

                return context$1$0.abrupt('return', { bundleId: windowParams[0], windowId: windowParams[1], cocoaId: windowParams[2] });

            case 27:
                if (!_osFamily2.default.linux) {
                    context$1$0.next = 29;
                    break;
                }

                return context$1$0.abrupt('return', { windowId: windowParams[0] });

            case 29:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this, [[3, 17]]);
};

module.exports = exports.default;