'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _findWindow = require('./find-window');

var _findWindow2 = _interopRequireDefault(_findWindow);

var _osFamily = require('os-family');

var _osFamily2 = _interopRequireDefault(_osFamily);

var _utilsExec = require('../utils/exec');

var _utilsEnsureDirectory = require('../utils/ensure-directory');

var _utilsEnsureDirectory2 = _interopRequireDefault(_utilsEnsureDirectory);

var _binaries = require('../binaries');

var _binaries2 = _interopRequireDefault(_binaries);

var _utilsLogFile = require('../utils/log-file');

var _utilsLogFile2 = _interopRequireDefault(_utilsLogFile);

/**
 * Takes a screenshot of the browser window where the specified web page is opened.
 * @function
 * @async
 * @name screenshot
 * @param {string | object} windowDescriptor - Specifies the title of the web page opened in the window or a descriptor returned by findWindow.
 * @param {string} screenshotPath - Specifies the full path to the screenshot file. For example, D:\Temp\chrome-screenshot.jpg.
 */

exports.default = function callee$0$0(windowDescriptor, screenshotPath) {
    var windowDescription, screenshotArguments;
    return _regeneratorRuntime.async(function callee$0$0$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                _utilsLogFile2.default('screenshot');

                context$1$0.next = 3;
                return _regeneratorRuntime.awrap(_utilsEnsureDirectory2.default(screenshotPath));

            case 3:
                if (context$1$0.sent) {
                    context$1$0.next = 6;
                    break;
                }

                _utilsLogFile2.default('screenshot failed to ensure dir');

                return context$1$0.abrupt('return');

            case 6:
                if (!(typeof windowDescriptor === 'string')) {
                    context$1$0.next = 12;
                    break;
                }

                context$1$0.next = 9;
                return _regeneratorRuntime.awrap(_findWindow2.default(windowDescriptor));

            case 9:
                context$1$0.t0 = context$1$0.sent;
                context$1$0.next = 13;
                break;

            case 12:
                context$1$0.t0 = windowDescriptor;

            case 13:
                windowDescription = context$1$0.t0;

                if (windowDescription) {
                    context$1$0.next = 17;
                    break;
                }

                _utilsLogFile2.default('screenshot failed to get window');
                return context$1$0.abrupt('return');

            case 17:
                screenshotArguments = void 0;

                if (_osFamily2.default.win) screenshotArguments = [windowDescription.hwnd, windowDescription.browser];else if (_osFamily2.default.mac) screenshotArguments = [windowDescription.cocoaId];else screenshotArguments = [windowDescription.windowId];

                _utilsLogFile2.default('screenshot before exec');

                context$1$0.next = 22;
                return _regeneratorRuntime.awrap(_utilsExec.execFile(_binaries2.default.screenshot, screenshotArguments.concat(screenshotPath)));

            case 22:

                _utilsLogFile2.default('screenshot after exec');

            case 23:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this);
};

module.exports = exports.default;